<?php /* -*- mode: php; indent-tabs-mode: nil; tab-width: 2; -*- */
if (!empty($xml_shebang)) {
  echo $xml_shebang;
}

$tpl_path = 'modules/system/page.tpl.php';

/*
 * Inspired by theme.inc:theme(). This seems the closest thing to
 * properly wrapping around an existing template at as low of a level
 * as is needed by the xhtml module.
 */
init_theme();
$hooks = theme_get_registry();
if (!empty($hooks['page'])) {
  $info = $hooks['page'];

  /* get all non-xhtml.module theme paths */
  $theme_paths = array();
  $xhtml_path = drupal_get_path('module', 'xhtml');
  foreach (array_merge($info['theme paths'], array($info['theme path'])) as $theme_path) {
    if (strpos($theme_path, $xhtml_path) === FALSE) {
      $theme_paths[] = $theme_path;
    }
  }

  /* get all non-xhtml.module templates */
  $suggestions = array();
  if (!empty($template_file))
    $template_files[] = $template_file;
  /*
   * Insert the default template, 'page', as the lowest priority as
   * it's the fallback. I don't know why it isn't already in the
   * suggestions array, but I guess drupal just doesn't quite work
   * that way.
   */
  array_unshift($template_files, 'page');
  /* Remove our self-reference */
  foreach ($template_files as $suggestion) {
    if (strpos($suggestion, 'xhtml') === FALSE) {
      $suggestions[] = $suggestion;
    }
  }

  $template_file = drupal_discover_template($theme_paths, $suggestions);
  if (!empty($template_file)) {
    $tpl_path = $template_file;
  }
}

/*
 * drupal6's drupal_get_html_head() unconditionally forces a meta
 * http-equiv Content-Type: text/html tag into <head/>. Remove this
 * one:
 */
$head = preg_replace('|<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />[^<]*|', '', $head);

ob_start();
require('.' . DIRECTORY_SEPARATOR . $tpl_path);
$page_html = ob_get_clean();

/*
 * OK, now comes some of the real magic: properly rewrangling the
 * silly http-equiv which drupal_final_markup() inserts into the
 * page. Fortunately for us, that function uses preg_replace() instead
 * of preg_replace_all(). It will take the first <head> tag it finds
 * and replace it with the meta http-equiv Content-Type: text/html
 * gunk. But we have one silly trick to fix this. Merely wrap the
 * first <head> tag drupal_final_markup() will find in a comment jail:
 */
echo preg_replace('|<head[^>]*>|i', '<!-- <head> -->' . PHP_EOL . '  $0', $page_html);
